Minimum Number of Vertices to Reach All Nodes

Minimum Number of Vertices to Reach All Nodes

Leetcode Daily Challenge (18th May, 2023)

Problem Statement:-

Given a directed acyclic graph, with n vertices numbered from 0 to n-1, and an array edges where edges[i] = [from<sub>i</sub>, to<sub>i</sub>] represents a directed edge from node from<sub>i</sub> to node to<sub>i</sub>.

Find the smallest set of vertices from which all nodes in the graph are reachable. It's guaranteed that a unique solution exists.

Notice that you can return the vertices in any order.

Link: https://leetcode.com/problems/minimum-number-of-vertices-to-reach-all-nodes/

Problem Explanation with examples:-

Example 1

Input: n = 6, edges = [[0,1],[0,2],[2,5],[3,4],[4,2]]
Output: [0,3]
Explanation: It's not possible to reach all the nodes from a single vertex. From 0 we can reach [0,1,2,5]. From 3 we can reach [3,4,2,5]. So we output [0,3].

Example 2

Input: n = 5, edges = [[0,1],[2,1],[3,1],[1,4],[2,4]]
Output: [0,2,3]
Explanation: Notice that vertices 0, 3 and 2 are not reachable from any other node, so we must include them. Also any of these vertices can reach nodes 1 and 4.

Constraints

  • 2 <= n <= 10^5

  • 1 <= edges.length <= min(10^5, n * (n - 1) / 2)

  • edges[i].length == 2

  • 0 <= from<sub>i,</sub> to<sub>i</sub> < n

  • All pairs (from<sub>i</sub>, to<sub>i</sub>) are distinct.

Intuition:-

  • Find all nodes and all destination nodes.

  • Find all source nodes by subtracting destination nodes from all nodes.

  • Return source nodes.

Solution:-

  • Create a set of all nodes by using range(n).

  • Create a set of all destination nodes by using list comprehension.

  • Create a set of all source nodes by subtracting destination nodes from all nodes using set difference.

  • Return source nodes by converting set to list.

Code:-

JAVA Solution

class Solution {
    public List<Integer> findSmallestSetOfVertices(int n, List<List<Integer>> edges) {
        Set<Integer> allNodes = new HashSet<>();
        for (int i = 0; i < n; i++) {
            allNodes.add(i);
        }

        Set<Integer> destinationNodes = new HashSet<>();
        for (List<Integer> edge : edges) {
            destinationNodes.add(edge.get(1));
        }

        Set<Integer> sourceNodes = new HashSet<>(allNodes);
        sourceNodes.removeAll(destinationNodes);

        return new ArrayList<>(sourceNodes);
    }
}

Python Solution

class Solution:
    def findSmallestSetOfVertices(self, n: int, edges: List[List[int]]) -> List[int]:
        all_nodes = set(range(n))
        destination_nodes = set(destination for _, destination in edges)
        source_nodes = all_nodes - destination_nodes

        return list(source_nodes)

Complexity Analysis:-

TIME:-

The time complexity is O(n) where n is the number of nodes in the graph as we are iterating over all nodes once.

SPACE:-

The space complexity is O(n) where n is the number of nodes in the graph as we are storing all nodes in a set.

References:-

Connect with me:-

Did you find this article valuable?

Support Leeting-LCS by becoming a sponsor. Any amount is appreciated!